"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createRebaser = void 0;
var parse5_html_rewriting_stream_1 = __importDefault(require("parse5-html-rewriting-stream"));
var source_map_1 = require("source-map");
var events_1 = require("events");
var url_1 = require("url");
var path_1 = require("path");
var stream_1 = require("stream");
var css_source_map_rebase_1 = require("css-source-map-rebase");
/**
 * Creates and returns a Rebaser instance.
 *
 * @param options
 */
var createRebaser = function (options) {
    if (options === void 0) { options = {}; }
    var eventEmitter = new events_1.EventEmitter();
    var rebase = function (html, map) {
        var rewritingStream = new parse5_html_rewriting_stream_1.default();
        var rebase = options.rebase;
        return new Promise(function (resolve, reject) { return __awaiter(void 0, void 0, void 0, function () {
            var regions_1, data_1, outputStream_1, isRebasable_1, queue_1, defer_1, findRegion_1, transformText_1, transformStartTag_1, currentStartTag_1, _i, _a, eventName, error_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _b.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, new source_map_1.SourceMapConsumer(map)
                                .then(function (sourceMapConsumer) {
                                var regions = [];
                                var region = null;
                                var currentSource = null;
                                sourceMapConsumer.eachMapping(function (mapping) {
                                    var source = mapping.source;
                                    if (source !== currentSource) {
                                        // end the current region...
                                        if (region) {
                                            region.endLine = mapping.generatedLine;
                                            region.endColumn = mapping.generatedColumn;
                                        }
                                        //...and start a new one
                                        region = {
                                            source: source,
                                            startLine: mapping.generatedLine,
                                            startColumn: mapping.generatedColumn,
                                            endLine: null,
                                            endColumn: null
                                        };
                                        regions.push(region);
                                        currentSource = source;
                                    }
                                }, null);
                                return regions;
                            })];
                    case 1:
                        regions_1 = _b.sent();
                        data_1 = Buffer.from('');
                        outputStream_1 = new stream_1.Writable({
                            write: function (chunk, _encoding, callback) {
                                data_1 = Buffer.concat([data_1, chunk]);
                                callback();
                            }
                        });
                        outputStream_1.on('finish', function () {
                            defer_1(function () {
                                return Promise.resolve(resolve({
                                    data: data_1,
                                    map: map
                                }));
                            });
                        });
                        rewritingStream.pipe(outputStream_1);
                        isRebasable_1 = function (url) {
                            return !(0, path_1.isAbsolute)(url.href) && (url.host === null) && ((url.hash === null) || (url.path !== null));
                        };
                        queue_1 = Promise.resolve();
                        defer_1 = function (execution) {
                            queue_1 = queue_1.then(execution);
                        };
                        findRegion_1 = function (startLine, startColumn) {
                            var i = 0;
                            var result = null;
                            var tagStartLine = startLine;
                            var tagStartColumn = startColumn;
                            while (result === null) {
                                var region = regions_1[i];
                                if (((region.startLine < tagStartLine) || ((region.startLine === tagStartLine) && (region.startColumn <= tagStartColumn))) &&
                                    ((region.endLine === null) || (region.endLine > tagStartLine) ||
                                        ((region.endLine === tagStartLine) && (region.endColumn === null || (region.endColumn >= tagStartColumn))))) {
                                    result = region;
                                }
                                i++;
                            }
                            return result;
                        };
                        transformText_1 = function (textToken, rawHtml) {
                            if ((currentStartTag_1 === null || currentStartTag_1 === void 0 ? void 0 : currentStartTag_1.tagName) !== "style") {
                                return Promise.resolve();
                            }
                            var _a = textToken.sourceCodeLocation, startLine = _a.startLine, startCol = _a.startCol, endLine = _a.endLine;
                            var numberOfLines = 1 + (endLine - startLine);
                            var region = findRegion_1(startLine, startCol);
                            var generator = new source_map_1.SourceMapGenerator();
                            for (var generatedLine = 1; generatedLine <= numberOfLines; generatedLine++) {
                                generator.addMapping({
                                    source: region.source,
                                    generated: {
                                        line: generatedLine,
                                        column: 0
                                    },
                                    original: {
                                        line: 1,
                                        column: 0
                                    }
                                });
                            }
                            generator.setSourceContent(region.source, rawHtml);
                            var cssRebaser = new css_source_map_rebase_1.Rebaser({
                                map: Buffer.from(generator.toString()),
                                rebase: rebase
                            });
                            cssRebaser.on("rebase", function (rebasedPath, resolvedPath) {
                                eventEmitter.emit('rebase', rebasedPath, resolvedPath);
                            });
                            return cssRebaser.rebase(Buffer.from(rawHtml))
                                .then(function (result) {
                                var css = result.css;
                                textToken.text = css.toString();
                            });
                        };
                        transformStartTag_1 = function (tag) { return __awaiter(void 0, void 0, void 0, function () {
                            var attributes, _loop_1, _i, attributes_1, attribute;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        attributes = tag.attrs;
                                        _loop_1 = function (attribute) {
                                            return __generator(this, function (_b) {
                                                switch (_b.label) {
                                                    case 0: return [4 /*yield*/, new Promise(function (resolve) {
                                                            switch (attribute.name) {
                                                                case 'href':
                                                                case 'src': {
                                                                    var url = (0, url_1.parse)(attribute.value);
                                                                    if (!isRebasable_1(url)) {
                                                                        resolve();
                                                                    }
                                                                    else {
                                                                        var _a = tag.sourceCodeLocation, startLine = _a.startLine, startCol = _a.startCol;
                                                                        var tagRegion = findRegion_1(startLine, startCol);
                                                                        var source = tagRegion.source;
                                                                        var resolvedPath_1 = path_1.posix.join((0, path_1.dirname)(source), url.pathname);
                                                                        var done = function (rebasedPath) {
                                                                            if (rebasedPath !== false) {
                                                                                if (!rebasedPath) { // default rebasing
                                                                                    rebasedPath = resolvedPath_1;
                                                                                }
                                                                                attribute.value = rebasedPath;
                                                                                eventEmitter.emit('rebase', rebasedPath, resolvedPath_1);
                                                                            }
                                                                            resolve();
                                                                        };
                                                                        if (!rebase) {
                                                                            rebase = function (_url, _source, done) {
                                                                                done();
                                                                            };
                                                                        }
                                                                        rebase(source, resolvedPath_1, done);
                                                                    }
                                                                    break;
                                                                }
                                                                default: {
                                                                    resolve();
                                                                }
                                                            }
                                                        })];
                                                    case 1:
                                                        _b.sent();
                                                        return [2 /*return*/];
                                                }
                                            });
                                        };
                                        _i = 0, attributes_1 = attributes;
                                        _a.label = 1;
                                    case 1:
                                        if (!(_i < attributes_1.length)) return [3 /*break*/, 4];
                                        attribute = attributes_1[_i];
                                        return [5 /*yield**/, _loop_1(attribute)];
                                    case 2:
                                        _a.sent();
                                        _a.label = 3;
                                    case 3:
                                        _i++;
                                        return [3 /*break*/, 1];
                                    case 4: return [2 /*return*/];
                                }
                            });
                        }); };
                        currentStartTag_1 = null;
                        rewritingStream.on('startTag', function (startTag) {
                            defer_1(function () {
                                currentStartTag_1 = startTag;
                                return transformStartTag_1(startTag)
                                    .then(function () {
                                    rewritingStream.emitStartTag(startTag);
                                });
                            });
                        });
                        rewritingStream.on('text', function (text, rawHtml) {
                            defer_1(function () {
                                return transformText_1(text, rawHtml)
                                    .then(function () {
                                    if (rewritingStream.writable) {
                                        rewritingStream.emitRaw(text.text);
                                    }
                                    else {
                                        outputStream_1.write(text.text);
                                    }
                                });
                            });
                        });
                        rewritingStream.on("endTag", function (endTag) {
                            defer_1(function () {
                                currentStartTag_1 = null;
                                rewritingStream.emitEndTag(endTag);
                                return Promise.resolve();
                            });
                        });
                        for (_i = 0, _a = ['doctype', 'comment']; _i < _a.length; _i++) {
                            eventName = _a[_i];
                            rewritingStream.on(eventName, function (_token, rawHtml) {
                                defer_1(function () {
                                    rewritingStream.emitRaw(rawHtml);
                                    return Promise.resolve();
                                });
                            });
                        }
                        rewritingStream.write(html.toString(), function () {
                            queue_1.then(function () {
                                rewritingStream.end();
                            });
                        });
                        return [3 /*break*/, 3];
                    case 2:
                        error_1 = _b.sent();
                        reject(error_1);
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        }); });
    };
    var rebaser = {
        rebase: rebase,
        on: function (event, listener) {
            eventEmitter.on(event, listener);
            return rebaser;
        }
    };
    return rebaser;
};
exports.createRebaser = createRebaser;
